﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
            Loaded += new RoutedEventHandler(button1_Click);
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            int num1 = 0, num2 = 0;
            if (!string.IsNullOrEmpty(textBox1.Text) && !string.IsNullOrEmpty(textBox2.Text))
            {
                num1 = Convert.ToInt32(textBox1.Text);
                num2 = Convert.ToInt32(textBox2.Text);

                int ret = DllTest.Add(Convert.ToInt32(textBox1.Text), Convert.ToInt32(textBox2.Text));
                textBlock3.Text = ret.ToString();
            }

            PersonInfo p = new PersonInfo();
            DllTest.TestStruct(ref p);

            //int dd = p.id;

            int[] intArray = new int[5];
            DllTest.TestIntArr(intArray);
            Debug.WriteLine(intArray);

            PersonInfo[] ps = new PersonInfo[5];
            DllTest.TestStructArray(ps);

            int t = Marshal.SizeOf(new StudentInfo());
            //  var t = sizeof(PersonInfo2);

            StudentInfo[] ps2 = new StudentInfo[3];
            DllTest.TestStructArray2(ps2);

            short[] name = ps2[0].name;
            string ret13 = new string(name.Where(o => o != 0).Select(o => (char)o).ToArray());

            char[] chars = new char[100];

            StringBuilder builder = new StringBuilder(256);
            DllTest.TestString(builder, 256);
        }

    }


    public class DllTest
    {
        [DllImport("Win32Dll.dll", EntryPoint = "Add")]
        public static extern Int32 Add(int a, int b);

        [DllImport("Win32Dll.dll", EntryPoint = "TestStruct")]
        public static extern Int32 TestStruct(ref PersonInfo person);

        [DllImport("Win32Dll.dll", EntryPoint = "TestStructArray")]
        public static extern Int32 TestStructArray([In, Out]  PersonInfo[] persons);

        [DllImport("Win32Dll.dll", EntryPoint = "TestStructArray2")]
        public static extern Int32 TestStructArray2([In, Out]  StudentInfo[] students);

        [DllImport("Win32Dll.dll", EntryPoint = "TestIntArr")]
        public static extern Int32 TestIntArr([In, Out] int[] intArray);

        [DllImport("Win32Dll.dll", EntryPoint = "TestString")]
        public static extern Int32 TestString([MarshalAs(UnmanagedType.LPTStr)]StringBuilder buffer, Int32 length);
    }

    [ComVisible(false), StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
    public struct PersonInfo
    {
        public int id;
        public char name;
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct StudentInfo
    {
        public int id;

        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 100)]
        public short[] name;
    }
}
